---
title: CanvasRenderingContext2D.strokeStyle
slug: Web/API/CanvasRenderingContext2D/strokeStyle
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D.strokeStyle</strong></code> property of the Canvas 2D API specifies the color, gradient, or pattern to use for the strokes (outlines) around shapes. The default is <code>#000</code> (black).</p>

<div class="note">
<p>For more examples of stroke and fill styles, see <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Applying_styles_and_colors">Applying styles and color</a> in the <a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas tutorial</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.strokeStyle = <em>color</em>;
<em>ctx</em>.strokeStyle = <em>gradient</em>;
<em>ctx</em>.strokeStyle = <em>pattern</em>;
</pre>

<h3 id="Options">Options</h3>

<dl>
 <dt><code>color</code></dt>
 <dd>A {{domxref("DOMString")}} parsed as <a href="/en-US/docs/Web/CSS">CSS</a> {{cssxref("&lt;color&gt;")}} value.</dd>
 <dt><code>gradient</code></dt>
 <dd>A {{domxref("CanvasGradient")}} object (a linear or radial gradient).</dd>
 <dt><code>pattern</code></dt>
 <dd>A {{domxref("CanvasPattern")}} object (a repeating image).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Changing_the_stroke_color_of_a_shape">Changing the stroke color of a shape</h3>

<p>This example applies a blue stroke color to a rectangle.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

ctx.strokeStyle = 'blue';
ctx.strokeRect(10, 10, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Changing_the_stroke_color_of_a_shape', 700, 160) }}</p>

<h3 id="Creating_multiple_stroke_colors_using_loops">Creating multiple stroke colors using loops</h3>

<p>In this example, we use two <code>for</code> loops and the {{domxref("CanvasRenderingContext2D.arc", "arc()")}} method to draw a grid of circles, each having a different stroke color. To achieve this, we use the two variables <code>i</code> and <code>j</code> to generate a unique RGB color for each circle, and only modify the green and blue values. (The red channel has a fixed value.)</p>

<div class="hidden">
<pre class="brush: html">&lt;canvas id="canvas" width="150" height="150"&gt;&lt;/canvas&gt;</pre>
</div>

<pre class="brush: js">var ctx = document.getElementById('canvas').getContext('2d');

for (let i = 0; i &lt; 6; i++) {
  for (let j = 0; j &lt; 6; j++) {
    ctx.strokeStyle = `rgb(
        0,
        ${Math.floor(255 - 42.5 * i)},
        ${Math.floor(255 - 42.5 * j)})`;
    ctx.beginPath();
    ctx.arc(12.5 + j * 25, 12.5 + i * 25, 10, 0, Math.PI * 2, true);
    ctx.stroke();
  }
}
</pre>

<p>The result looks like this:</p>

<p>{{EmbedLiveSample("Creating_multiple_stroke_colors_using_loops", "180", "180", "https://mdn.mozillademos.org/files/253/Canvas_strokestyle.png")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-strokestyle", "CanvasRenderingContext2D.strokeStyle")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.strokeStyle")}}</p>

<h3 id="WebKitBlink-specific_note">WebKit/Blink-specific note</h3>

<p>In WebKit- and Blink-based browsers, the non-standard and deprecated method <code>ctx.setStrokeColor()</code> is implemented in addition to this property.</p>

<pre class="brush: js">setStrokeColor(color, optional alpha);
setStrokeColor(grayLevel, optional alpha);
setStrokeColor(r, g, b, a);
setStrokeColor(c, m, y, k, a);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasGradient")}}</li>
 <li>{{domxref("CanvasPattern")}}</li>
</ul>
